#include "commonfunc.h"
#include <vector>

namespace ADC
{
    namespace common
    {
        //BA----
        float k_BA_DesLCPntTH1st = 40.0f; // sec 50
        float k_BA_DesLCPntTH2nd = 30.0f; // sec 50
        float k_BA_DesLCPntTH3rd = 22.0f; // sec 30
        float k_BA_DesLCPntTH4th = 15.0f;
        float k_BA_DesLCPntTH1st_B = 50.0f; // sec gap 15
        float k_BA_DesLCPntTH2nd_B = 40.0f; // sec gap 15
        float k_BA_DesLCPntTH3rd_B = 32.0f; // sec gap 15
        float k_BA_DesLCPntTH4th_B = 20.0f; // sec gap 10
        float k_BA_DesLCPntLowThr1st = 1100.0f; // m
        float k_BA_DesLCPntLowThr2nd = 1400.0f; // m 1300
        float k_BA_DesLCPntLowThr3rd = 1700.0f; // m 1600
        float k_BA_DesLCPntLowThr4th = 1900.0f; // m 1800
        float k_BA_SpprLCDistThrd01 = 1500.0f;                   // m 1200
        float k_BA_SpprLCDistThrd02 = 2500.0f;                   // m 1500
        float k_BA_AntiDrctLCDist2LastLCPntThr_Aggr = 800.0f;
        float k_BA_AntiDrctLCDist2LastLCPntThr_Cnsr = 1300.0f;
        float k_BA_DrcnIndAheadOnDistThrd = 80.0f;
        float k_BA_DrcnIndAheadOnDistThrd02 = 80.0f;
        float k_BA_LineFllwDrcnIndOnDurThr = 8.5f;
        float k_BA_VehFlowCalcMaxRng = 250.0f;
        bool k_BA_AlwysLCR4SpltTypWP = true;
        float k_BA_DistThr4LCR = 1500.0f; // m
        float k_BA_EffcTrffcCostSpdPerc = 0.1f;
        float k_BA_EffcTrffcCostSpdPerc01 = 0.2f;
        float k_BA_EffcTrffcCostSpdPerc02 = 0.3f;
        float k_BA_AllwAntiLCObjDstThr = 60.0f; // m
        float k_BA_MinLaneEndLCPntDst = 50.0f; // m
        float k_BA_CnnctRmpSetSpdThr = 45.0f; // kph
        float k_BA_Dst2FrtNrstOffsetThr = 120.0f; // m
        float k_BA_MinFrtNrstLnLgthInCnctRmp = 60.0f; // m
        float k_BA_CnnctRmpSetSpdThr01 = 50.0f; // kph
        float k_BA_Dst2FrtNrstOffsetThr01 = 80.0f; // m
        float k_BA_MinFrtNrstLnLgthInCnctRmp01 = 140.0f; // m
        float k_BA_PreviewTH4CurvCalc = 2.0f; // sec
        float k_BA_AutoLCCrvHighThr = 0.004f; // m-1
        float k_BA_AutoLCCrvLowThr = 0.00333f; // m-1
        float k_BA_LnEndTHThr01 = 7.5f; // sec
        float k_BA_MinLaneEndLCPntDst01 = 65.0f; // m
        float k_BA_LnEndTHThr = 5.0f; // sec
        bool k_BA_AutoLCCrvInFlg = true;
        bool k_BA_LaneEndWrnInFlg = true;
        float k_BA_MaxLnChgAblNotDrvCmdDur = 2.5f; // sec
        bool k_BA_SmaNrrwLnInFlg = false;
        float k_BA_SmaNrrwLnOffsetThrd01 = 300.0f; // m
        float k_BA_LaneEndOffsetSpprThr = 800.0f; // m
        float k_BA_UpgradeDrvMdLnEndRngThr = 200.0f; // m
        bool k_BA_ChgTRPLatStsAllw = true;
        bool k_BA_InclLCP4SlowLnCost = true;
        bool k_BA_AlphaVehFlowCalcAppl = true;
        float k_BA_LowSpdRegionLowThr = 45.0f; // kph
        float k_BA_LowSpdRegionHighThr = 55.0f; // kph
        bool k_BA_ChgDrvMdWaitLongEnough = true;
        float k_BA_ChgDrvMdWaitDurTmThr = 50.0f; // sec
        float k_BA_LCIntervalLvl01 = 3.5f; // sec
        float k_BA_MinCoolDur4LCRmpMrgCARd = 0.5f; // sec
        float k_BA_MinTHBtwFrtNrstObj = 5.0f; // sec
        float k_BA_SpdGap4AlphaVehFlowCalc = 4.5f; // m/s

        // RMUpdate
        bool k_RMU_LCPUseILCCorridor = false;

        /************************ObjSelect******************/
        vector<float> k_BA_LCGEstDistSpd = {0, 2.5, 10, 20, 50, 60};
        vector<float> k_BA_LCGEstDistLv2 = {3.3, 10.0, 18.0, 39.0, 76.0, 91.0};
        vector<float> k_BA_LCGEstDistLv3 = {3.5, 10.0, 20.0, 40.0, 100.0, 120.0};
        vector<float> k_BA_LCGEstDistLv2_bck = {3.3, 10.0, 20.0, 43.0, 76.0, 91.0};
        vector<float> k_BA_LCGEstDistLv3_bck = {3.5, 10.0, 22.0, 45.0, 100.0, 120.0};

        float k_BA_BNAEgoLneFctr = 0.45;
        float k_BA_BNATarLneFctr = 0.5;
        float k_BA_BNALcpEgoLneFctr_bck = 0.12;
        float k_BA_BNALcpEgoLneFctr_frt = 0.25;    //1117  split Fctr into frt_Fctr and bck_Fctr , using new value(0.25)  as frt sfty value;

        vector<float> k_BA_LCGAlcTarBckReGainSpd = {0.0, 8.3, 11.11, 15.2, 16.67, 18.05, 22.22, 33.33};
        vector<float> k_BA_LCGAlcTarBckReGainTb = {0.75, 0.75, 0.68, 0.65, 0.65, 0.65, 0.72, 0.8};   // reduce mid spd section gain value to enhance bck tolrance 0907

        vector<float> k_BA_LCGAlcAbltTorGainTb = {0.65, 0.7, 0.72, 0.85, 1.0};     // reduce torGain to aviod LC Abolition with long-action time 0907
        vector<float> k_BA_LCGAlcAbltTorC0 = {1.0, 1.1, 1.3, 1.5, 1.7};
        float k_BA_LCGAlcAbltTorGainLo = 0.7;
        float k_BA_LCGAlcAbltTorGainHi = 1.0;
        bool k_BA_LCGAlcAbltTorOff = false;

        float k_BA_LCGALCSRLv1Gain_Bsic = 1.2;
        float k_BA_LCGALCSRLv2Gain_Bsic = 0.95;
        float k_BA_LCGALCSRLv3Gain_Bsic = 0.7;

        float k_BA_LCGAlcEgoReGain = 0.8;
        float k_BA_LCGLCLCPFlowGain = 0.9;

        float k_BA_LCGLCPBckScNrObjSpdThr = 8.88;
        float k_BA_LCGLCPBckScNrObjSpdErrThr = 5.55;

        float k_BA_LCGLCSpdErrSftyThr_frt = 15.2;
        float k_BA_LCGLCSpdErrSftyThr_bck = 12.5;
        float k_BA_LCGLCSpdErrSftyThr_refrt = 16.6;
        float k_BA_LCGLCSpdErrSftyThr_rebck = 13.8;

        vector<float> k_BA_LCGLCPBckArvEstTmThrSpdFctr = {0, 11.11, 22.22, 33.33, 44.44};
        vector<float> k_BA_LCGLCPBckDynArvTm = {6.0, 8.0, 10.0, 10.0, 11.0};

        vector<float> k_BA_LCGDistCmprsSpdErrFctr = {0.0, 3.0, 6.0, 6.1};

        vector<float> k_BA_LCGDistCmprsGain = {1.0, 0.75, 0.65, 0.64};
        vector<float> k_BA_LCGDistCmprsGain_Cnsrv = {1.0, 0.8, 0.8, 0.81};
        vector<float> k_BA_LCGDistCmprsGain_Agrsv = {1.0, 0.65, 0.58, 0.57};
        vector<float> k_BA_LCGDistReCmprsGain = {1.0, 1.18, 1.24, 1.25};
        vector<float> k_BA_LCGDistReCmprsGain_Cnsrv = {1.0, 1.20, 1.3, 1.31};
        vector<float> k_BA_LCGDistReCmprsGain_Agrsv = {1.0, 1.05, 1.1, 1.11};

        vector<float> k_BA_LCGBckCmprsSpdErr = {-6.0, -3.0, 0.0, 3.0, 6.0};
        vector<float> k_BA_LCGBckCmprsEgoSpd = {11.11, 16.66, 22.22, 33.33};
        vector<float> k_BA_LCGBckCmprsTb = {1.4, 1.3, 1.2, 0.85, 0.65, 1.4, 1.25, 1.1, 0.8, 0.65, 1.4, 1.2, 1, 0.75, 0.65, 1.4, 1.0, 0.85, 0.7, 0.6};

        bool k_BA_BNAPDCostUnexpectRskOn_ALL = true;
        float k_BA_BNAUnexpectObjPnshCost = 9.0;
        float k_BA_BNANormalRskTTCDgrCost = 8.0;
    } // namespace common

    // ***********************PD**************************//
    float PD_lgttrj_inacclmt = 1.5;
    float PD_lgttrj_deacclmt = -1.5;
    float PD_lgttrj_inaccthrs = -0.5;
    float PD_lgttrj_deaccthrs = 0.5;
    float PD_VehBckLaneC0LmtVal = 0.43;
    float PD_RdEndClsnTimeVal = 6.0;  
    float PD_LgtAccThrsVal = 2.5;
    int PD_LgtCrsLneIndx = 3; 
    int PD_ChkClsn_timesize = 30; 
    float PD_CostBckDist2R = -6.0; 
    float PD_CostFrtDist2R = 8.0; 
    float PD_CostNearLatOffSet2R = 1.2; 
    float PD_CostBckDist3L = -6.0;
    float PD_CostFrtDist3L = 8.0;
    float PD_CostNearLatOffSet3L = 1.2;

    float PD_NodeLgtClsnRltvDist = 3.0;
    float PD_Nodelat2reflindist = 0.5;
    float PD_NodeCrslineValC0 = 0.8;
    float PD_CostCrossLine = 2.95;
    float PD_CostLatThrDltaVminSame1 = 1.6;
    float PD_CostLatThrDltaVmaxSame1 = 1.6;
    float PD_CostLatThrDltaVminSame2 = 1.4;
    float PD_CostLatThrDltaVmaxSame2 = 1.4;
    float PD_CostLatThrDltaVminLCP = 0.5;
    float PD_CostLatThrDltaVmaxLCP = 0.5;
    float PD_CostLatThrDltaVminOther = 0.7;
    float PD_CostLatThrDltaVmaxOther = 0.7; 

    // no use
    float PD_CostDltaVmin = 5.56;
    float PD_CostDltaVmax = 11.11;
    float PD_CostLatThrRelVmin = 1.0;
    float PD_CostLatThrRelVmax = 1.0;

    float PD_CostInterstObjLatDis = 12.0; 
    float PD_CostEgoBackLatOffSetL = -1.95; //left/right neighbor lane object lgt calculation lat threshold value
    float PD_CostEgoBackLatOffSetR = 1.95; // 1.85---1.95
    float PD_CostEgoBackLatOffSetLF = 1.95;
    float PD_CostLatOffSetObjInLaneLL = 1.85;
    float PD_CostLatOffSetObjInLaneRR = -1.85; // right right neighbor lane object lgt calculation lat threshold value
    float PD_CostLatAbsDisOther = 5.5; // left left/right right neighbor lane object behavior lateral threshold value
    int PD_CostSizeObjInEgoLaneList = 24; // ego lane object size
    int PD_CostSizeObjInEgoLaneListL = 17; // left neighbor lane object size
    int PD_CostSizeObjInEgoLaneListLL = 8; // left left neighbor lane object size
    int PD_CostSizeObjOtherLaneList = 5;
    int PD_CostSizeObjLCP = 5; // LCP behavior size
    std::vector<float> PD_CostRelativeVelocity = {0.0, 3.0, 6.0, 6.1};     // Add 0818
    std::vector<float> PD_CostGainTrgtFrtDist = {1.0, 1.11, 1.25, 1.47}; // 1, 1/0.9, 1/0.8, 1/0.78 // for target lane front object gain para with speed 
    std::vector<float> PD_CostGainTrgtFrtTD = {1.0, 1.11, 1.25, 1.47};

} // namespace ADC
